using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Org.Shokai.Util
{
    /// <summary>
    /// ϏfQ[g
    /// </summary>
    /// <param name="msg"></param>
    delegate void StringDataDelegate(string msg);
    delegate void VoidDelegate();

    /// <summary>
    /// TraceptH[ fobOȂǂɎg
    /// </summary>
    public partial class TraceForm : Form
    {
        public TraceForm()
        {
            InitializeComponent();
        }

        public TraceForm(String title)
        {
            InitializeComponent();
            this.Text = title;
        }

        /// <summary>
        /// TraceFormɕ
        /// </summary>
        /// <param name="msg">Trace\镶</param>
        public void write(string msg)
        {
            Console.WriteLine(msg);
#if DEBUG
            StringDataDelegate traceDelegate = TextBox_write;
            try
            {
                this.Invoke(traceDelegate, msg);
            }
            catch (InvalidAsynchronousStateException e)
            {
                Console.WriteLine(e.Message);
            }
#endif
        }

        /// <summary>
        /// write(string)DelegateoRŌĂ΂
        /// </summary>
        /// <param name="str">Trace\镶</param>
        private void TextBox_write(string str)
        {
            textBox.Text = str + "\r\n" + textBox.Text;
        }

        /// <summary>
        /// TraceFormNA
        /// </summary>
        public void clear()
        {
            VoidDelegate vDelegate = TextBox_clear;
            try
            {
                this.Invoke(vDelegate);
            }
            catch (InvalidAsynchronousStateException e)
            {
                Console.WriteLine(e.Message);
            }
        }

        /// <summary>
        /// clear()DelegateoRŌĂ΂
        /// </summary>
        private void TextBox_clear()
        {
            textBox.Text = "";
        }

        private void buttonClear_Click(object sender, EventArgs e)
        {
            textBox.Text = "";
        }
    }
}