using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;


namespace GpsTest
{
    public partial class GpsTest : Form
    {
        delegate void StringDataDelegate(string msg);

        public GpsTest()
        {
            InitializeComponent();
            for (int i = 1; i <= 20; i++) // R{{bNXɃACeǉ
            {
                comboBox1.Items.Add("COM" + i);
            }
            comboBox1.SelectedIndex = 0;
        }

        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            try
            {
                String recvData = serialPort1.ReadLine();
                String[] data = recvData.Split(',');
                switch (data[0])
                {
                    case "$GPGGA":
                        write("ܓx" + data[3]+" "+data[2]);
                        write("ox" + data[5]+" "+data[4]);
                        break;
                    case "$GPRMC":
                        break;
                    case "$GPGSA":
                        break;
                }
                //Console.Write(recvData);
                write(recvData);
            }
            catch
            {
                Console.WriteLine(e.ToString());
            }
        }


        private void button1_Click(object sender, EventArgs e)
        {
            // VA|[gJ肷
            if (serialPort1.IsOpen)
            {
                serialPort1.Close();
                if (!serialPort1.IsOpen) // ꂽ
                {
                    comboBox1.Enabled = true;
                    button1.Text = "Connect";
                }
            }
            else
            {
                serialPort1.Open();
                if (serialPort1.IsOpen) // JĂ
                {
                    comboBox1.Enabled = false;
                    button1.Text = "Close";
                }
            }
        }

        /// <summary>
        /// TraceFormɕ
        /// </summary>
        /// <param name="msg">Trace\镶</param>
        public void write(string msg)
        {
            Console.WriteLine(msg);
            StringDataDelegate traceDelegate = TextBox_write;
            try
            {
                this.Invoke(traceDelegate, msg);
            }
            catch (InvalidAsynchronousStateException e)
            {
                Console.WriteLine(e.Message);
            }
        }

        /// <summary>
        /// write(string)DelegateoRŌĂ΂
        /// </summary>
        /// <param name="str">Trace\镶</param>
        private void TextBox_write(string str)
        {
            textBox1.Text = str + "\r\n" + textBox1.Text;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            textBox1.Text = "";
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            serialPort1.PortName = (String)comboBox1.Items[comboBox1.SelectedIndex];
        }

    }
}